Index: amd64/linux32/syscalls.master
===================================================================
RCS file: /home/ncvs/src/sys/amd64/linux32/syscalls.master,v
retrieving revision 1.10
diff -u -u -r1.10 syscalls.master
--- amd64/linux32/syscalls.master	13 Jun 2006 18:43:55 -0000	1.10
+++ amd64/linux32/syscalls.master	20 Jun 2006 20:36:40 -0000
@@ -1,4 +1,4 @@
- $FreeBSD: src/sys/amd64/linux32/syscalls.master,v 1.10 2006/06/13 18:43:55 netchild Exp $
+ $FreeBSD: src/sys/amd64/linux32/syscalls.master,v 1.9 2006/05/10 18:17:28 netchild Exp $
 
 ;	@(#)syscalls.master	8.1 (Berkeley) 7/19/93
 ; System call name/number master file (or rather, slave, from LINUX).
@@ -418,61 +418,61 @@
 251	AUE_NULL	UNIMPL
 252	AUE_EXIT	MNOPROTO { void sys_exit(int rval); } exit_group \
 				    sys_exit_args void
-253	AUE_NULL	UNIMPL	linux_lookup_dcookie
-254	AUE_NULL	UNIMPL	linux_epoll_create
-255	AUE_NULL	UNIMPL	linux_epoll_ctl
-256	AUE_NULL	UNIMPL	linux_epoll_wait
-257	AUE_NULL	UNIMPL	linux_remap_file_pages
-258	AUE_NULL	UNIMPL	linux_set_tid_address
-259	AUE_NULL	UNIMPL	linux_timer_create
-260	AUE_NULL	UNIMPL	linux_timer_settime
-261	AUE_NULL	UNIMPL	linux_timer_gettime
-262	AUE_NULL	UNIMPL	linux_timer_getoverrun
-263	AUE_NULL	UNIMPL	linux_timer_delete
-264	AUE_CLOCK_SETTIME	UNIMPL	linux_clock_settime
-265	AUE_NULL	UNIMPL	linux_clock_gettime
-266	AUE_NULL	UNIMPL	linux_clock_getres
-267	AUE_NULL	UNIMPL	linux_clock_nanosleep
-268	AUE_NULL	UNIMPL	linux_statfs64
-269	AUE_NULL	UNIMPL	linux_fstatfs64
-270	AUE_NULL	UNIMPL	linux_tgkill	/* 270 */
-271	AUE_NULL	UNIMPL	linux_utimes
-272	AUE_NULL	UNIMPL	linux_fadvise64_64
-273	AUE_NULL	UNIMPL	linux_ni_syscall	/* linux_vserver */
-274	AUE_NULL	UNIMPL	linux_mbind
-275	AUE_NULL	UNIMPL	linux_get_mempolicy
-276	AUE_NULL	UNIMPL	linux_set_mempolicy
-277	AUE_NULL	UNIMPL	linux_mq_open
-278	AUE_NULL	UNIMPL	linux_mq_unlink
-279	AUE_NULL	UNIMPL	linux_mq_timedsend
-280	AUE_NULL	UNIMPL	linux_mq_timedreceive	/* 280 */
-281	AUE_NULL	UNIMPL	linux_mq_notify
-282	AUE_NULL	UNIMPL	linux_mq_getsetattr
-283	AUE_NULL	UNIMPL	linux_kexec_load
-284	AUE_NULL	UNIMPL	linux_waitid
-285	AUE_NULL	UNIMPL	linux_ni_syscall		/* 285 */ /* available */
-286	AUE_NULL	UNIMPL	linux_add_key
-287	AUE_NULL	UNIMPL	linux_request_key
-288	AUE_NULL	UNIMPL	linux_keyctl
-289	AUE_NULL	UNIMPL	linux_ioprio_set
-290	AUE_NULL	UNIMPL	linux_ioprio_get		/* 290 */
-291	AUE_NULL	UNIMPL	linux_inotify_init
-292	AUE_NULL	UNIMPL	linux_inotify_add_watch
-293	AUE_NULL	UNIMPL	linux_inotify_rm_watch
-294	AUE_NULL	UNIMPL	linux_migrate_pages
-295	AUE_NULL	UNIMPL	linux_openat		/* 295 */
-296	AUE_NULL	UNIMPL	linux_mkdirat
-297	AUE_NULL	UNIMPL	linux_mknodat
-298	AUE_NULL	UNIMPL	linux_fchownat
-299	AUE_NULL	UNIMPL	linux_futimesat
-300	AUE_NULL	UNIMPL	linux_fstatat64		/* 300 */
-301	AUE_NULL	UNIMPL	linux_unlinkat
-302	AUE_NULL	UNIMPL	linux_renameat
-303	AUE_NULL	UNIMPL	linux_linkat
-304	AUE_NULL	UNIMPL	linux_symlinkat
-305	AUE_NULL	UNIMPL	linux_readlinkat		/* 305 */
-306	AUE_NULL	UNIMPL	linux_fchmodat
-307	AUE_NULL	UNIMPL	linux_faccessat
-308	AUE_NULL	UNIMPL	linux_pselect6
-309	AUE_NULL	UNIMPL	linux_ppoll
-310	AUE_NULL	UNIMPL	linux_unshare		/* 310 */
+253	AUE_NULL	MSTD	{ int linux_lookup_dcookie(void); }
+254	AUE_NULL	MSTD	{ int linux_epoll_create(void); }
+255	AUE_NULL	MSTD	{ int linux_epoll_ctl(void); }
+256	AUE_NULL	MSTD	{ int linux_epoll_wait(void); }
+257	AUE_NULL	MSTD	{ int linux_remap_file_pages(void); }
+258	AUE_NULL	MSTD	{ int linux_set_tid_address(void); }
+259	AUE_NULL	MSTD	{ int linux_timer_create(void); }
+260	AUE_NULL	MSTD	{ int linux_timer_settime(void); }
+261	AUE_NULL	MSTD	{ int linux_timer_gettime(void); }
+262	AUE_NULL	MSTD	{ int linux_timer_getoverrun(void); }
+263	AUE_NULL	MSTD	{ int linux_timer_delete(void); }
+264	AUE_CLOCK_SETTIME	MSTD	{ int linux_clock_settime(void); }
+265	AUE_NULL	MSTD	{ int linux_clock_gettime(void); }
+266	AUE_NULL	MSTD	{ int linux_clock_getres(void); }
+267	AUE_NULL	MSTD	{ int linux_clock_nanosleep(void); }
+268	AUE_NULL	MSTD	{ int linux_statfs64(void); }
+269	AUE_NULL	MSTD	{ int linux_fstatfs64(void); }
+270	AUE_NULL	MSTD	{ int linux_tgkill(void); }
+271	AUE_NULL	MSTD	{ int linux_utimes(void); }
+272	AUE_NULL	MSTD	{ int linux_fadvise64_64(void); }
+273	AUE_NULL	UNIMPL
+274	AUE_NULL	MSTD	{ int linux_mbind(void); }
+275	AUE_NULL	MSTD	{ int linux_get_mempolicy(void); }
+276	AUE_NULL	MSTD	{ int linux_set_mempolicy(void); }
+277	AUE_NULL	MSTD	{ int linux_mq_open(void); }
+278	AUE_NULL	MSTD	{ int linux_mq_unlink(void); }
+279	AUE_NULL	MSTD	{ int linux_mq_timedsend(void); }
+280	AUE_NULL	MSTD	{ int linux_mq_timedreceive(void); }
+281	AUE_NULL	MSTD	{ int linux_mq_notify(void); }
+282	AUE_NULL	MSTD	{ int linux_mq_getsetattr(void); }
+283	AUE_NULL	MSTD	{ int linux_kexec_load(void); }
+284	AUE_NULL	MSTD	{ int linux_waitid(void); }
+285	AUE_NULL	UNIMPL
+286	AUE_NULL	MSTD	{ int linux_add_key(void); }
+287	AUE_NULL	MSTD	{ int linux_request_key(void); }
+288	AUE_NULL	MSTD	{ int linux_keyctl(void); }
+289	AUE_NULL	MSTD	{ int linux_ioprio_set(void); }
+290	AUE_NULL	MSTD	{ int linux_ioprio_get(void); }
+291	AUE_NULL	MSTD	{ int linux_inotify_init(void); }
+292	AUE_NULL	MSTD	{ int linux_inotify_add_watch(void); }
+293	AUE_NULL	MSTD	{ int linux_inotify_rm_watch(void); }
+294	AUE_NULL	MSTD	{ int linux_migrate_pages(void); }
+295	AUE_NULL	MSTD	{ int linux_openat(void); }
+296	AUE_NULL	MSTD	{ int linux_mkdirat(void); }
+297	AUE_NULL	MSTD	{ int linux_mknodat(void); }
+298	AUE_NULL	MSTD	{ int linux_fchownat(void); }
+299	AUE_NULL	MSTD	{ int linux_futimesat(void); }
+300	AUE_NULL	MSTD	{ int linux_fstatat64(void); }
+301	AUE_NULL	MSTD	{ int linux_unlinkat(void); }
+302	AUE_NULL	MSTD	{ int linux_renameat(void); }
+303	AUE_NULL	MSTD	{ int linux_linkat(void); }
+304	AUE_NULL	MSTD	{ int linux_symlinkat(void); }
+305	AUE_NULL	MSTD	{ int linux_readlinkat(void); }
+306	AUE_NULL	MSTD	{ int linux_fchmodat(void); }
+307	AUE_NULL	MSTD	{ int linux_faccessat(void); }
+308	AUE_NULL	MSTD	{ int linux_pselect6(void); }
+309	AUE_NULL	MSTD	{ int linux_ppoll(void); }
+310	AUE_NULL	MSTD	{ int linux_unshare(void); }
Index: i386/linux/syscalls.master
===================================================================
RCS file: /home/ncvs/src/sys/i386/linux/syscalls.master,v
retrieving revision 1.67
diff -u -u -r1.67 syscalls.master
--- i386/linux/syscalls.master	13 Jun 2006 18:43:55 -0000	1.67
+++ i386/linux/syscalls.master	20 Jun 2006 20:36:40 -0000
@@ -1,4 +1,4 @@
- $FreeBSD: src/sys/i386/linux/syscalls.master,v 1.67 2006/06/13 18:43:55 netchild Exp $
+ $FreeBSD: src/sys/i386/linux/syscalls.master,v 1.66 2006/05/10 18:17:29 netchild Exp $
 
 ;	@(#)syscalls.master	8.1 (Berkeley) 7/19/93
 ; System call name/number master file (or rather, slave, from LINUX).
@@ -419,61 +419,61 @@
 251	AUE_NULL	UNIMPL
 252	AUE_EXIT	MNOPROTO { void sys_exit(int rval); } exit_group \
 				    sys_exit_args void
-253	AUE_NULL	UNIMPL	linux_lookup_dcookie
-254	AUE_NULL	UNIMPL	linux_epoll_create
-255	AUE_NULL	UNIMPL	linux_epoll_ctl
-256	AUE_NULL	UNIMPL	linux_epoll_wait
-257	AUE_NULL	UNIMPL	linux_remap_file_pages
-258	AUE_NULL	UNIMPL	linux_set_tid_address
-259	AUE_NULL	UNIMPL	linux_timer_create
-260	AUE_NULL	UNIMPL	linux_timer_settime
-261	AUE_NULL	UNIMPL	linux_timer_gettime
-262	AUE_NULL	UNIMPL	linux_timer_getoverrun
-263	AUE_NULL	UNIMPL	linux_timer_delete
-264	AUE_CLOCK_SETTIME	UNIMPL	linux_clock_settime
-265	AUE_NULL	UNIMPL	linux_clock_gettime
-266	AUE_NULL	UNIMPL	linux_clock_getres
-267	AUE_NULL	UNIMPL	linux_clock_nanosleep
-268	AUE_NULL	UNIMPL	linux_statfs64
-269	AUE_NULL	UNIMPL	linux_fstatfs64
-270	AUE_NULL	UNIMPL	linux_tgkill	/* 270 */
-271	AUE_NULL	UNIMPL	linux_utimes
-272	AUE_NULL	UNIMPL	linux_fadvise64_64
-273	AUE_NULL	UNIMPL	linux_ni_syscall	/* linux_vserver */
-274	AUE_NULL	UNIMPL	linux_mbind
-275	AUE_NULL	UNIMPL	linux_get_mempolicy
-276	AUE_NULL	UNIMPL	linux_set_mempolicy
-277	AUE_NULL	UNIMPL	linux_mq_open
-278	AUE_NULL	UNIMPL	linux_mq_unlink
-279	AUE_NULL	UNIMPL	linux_mq_timedsend
-280	AUE_NULL	UNIMPL	linux_mq_timedreceive	/* 280 */
-281	AUE_NULL	UNIMPL	linux_mq_notify
-282	AUE_NULL	UNIMPL	linux_mq_getsetattr
-283	AUE_NULL	UNIMPL	linux_kexec_load
-284	AUE_NULL	UNIMPL	linux_waitid
-285	AUE_NULL	UNIMPL	linux_ni_syscall		/* 285 */ /* available */
-286	AUE_NULL	UNIMPL	linux_add_key
-287	AUE_NULL	UNIMPL	linux_request_key
-288	AUE_NULL	UNIMPL	linux_keyctl
-289	AUE_NULL	UNIMPL	linux_ioprio_set
-290	AUE_NULL	UNIMPL	linux_ioprio_get		/* 290 */
-291	AUE_NULL	UNIMPL	linux_inotify_init
-292	AUE_NULL	UNIMPL	linux_inotify_add_watch
-293	AUE_NULL	UNIMPL	linux_inotify_rm_watch
-294	AUE_NULL	UNIMPL	linux_migrate_pages
-295	AUE_NULL	UNIMPL	linux_openat		/* 295 */
-296	AUE_NULL	UNIMPL	linux_mkdirat
-297	AUE_NULL	UNIMPL	linux_mknodat
-298	AUE_NULL	UNIMPL	linux_fchownat
-299	AUE_NULL	UNIMPL	linux_futimesat
-300	AUE_NULL	UNIMPL	linux_fstatat64		/* 300 */
-301	AUE_NULL	UNIMPL	linux_unlinkat
-302	AUE_NULL	UNIMPL	linux_renameat
-303	AUE_NULL	UNIMPL	linux_linkat
-304	AUE_NULL	UNIMPL	linux_symlinkat
-305	AUE_NULL	UNIMPL	linux_readlinkat		/* 305 */
-306	AUE_NULL	UNIMPL	linux_fchmodat
-307	AUE_NULL	UNIMPL	linux_faccessat
-308	AUE_NULL	UNIMPL	linux_pselect6
-309	AUE_NULL	UNIMPL	linux_ppoll
-310	AUE_NULL	UNIMPL	linux_unshare		/* 310 */
+253	AUE_NULL	MSTD	{ int linux_lookup_dcookie(void); }
+254	AUE_NULL	MSTD	{ int linux_epoll_create(void); }
+255	AUE_NULL	MSTD	{ int linux_epoll_ctl(void); }
+256	AUE_NULL	MSTD	{ int linux_epoll_wait(void); }
+257	AUE_NULL	MSTD	{ int linux_remap_file_pages(void); }
+258	AUE_NULL	MSTD	{ int linux_set_tid_address(void); }
+259	AUE_NULL	MSTD	{ int linux_timer_create(void); }
+260	AUE_NULL	MSTD	{ int linux_timer_settime(void); }
+261	AUE_NULL	MSTD	{ int linux_timer_gettime(void); }
+262	AUE_NULL	MSTD	{ int linux_timer_getoverrun(void); }
+263	AUE_NULL	MSTD	{ int linux_timer_delete(void); }
+264	AUE_CLOCK_SETTIME	MSTD	{ int linux_clock_settime(void); }
+265	AUE_NULL	MSTD	{ int linux_clock_gettime(void); }
+266	AUE_NULL	MSTD	{ int linux_clock_getres(void); }
+267	AUE_NULL	MSTD	{ int linux_clock_nanosleep(void); }
+268	AUE_NULL	MSTD	{ int linux_statfs64(void); }
+269	AUE_NULL	MSTD	{ int linux_fstatfs64(void); }
+270	AUE_NULL	MSTD	{ int linux_tgkill(void); }
+271	AUE_NULL	MSTD	{ int linux_utimes(void); }
+272	AUE_NULL	MSTD	{ int linux_fadvise64_64(void); }
+273	AUE_NULL	UNIMPL
+274	AUE_NULL	MSTD	{ int linux_mbind(void); }
+275	AUE_NULL	MSTD	{ int linux_get_mempolicy(void); }
+276	AUE_NULL	MSTD	{ int linux_set_mempolicy(void); }
+277	AUE_NULL	MSTD	{ int linux_mq_open(void); }
+278	AUE_NULL	MSTD	{ int linux_mq_unlink(void); }
+279	AUE_NULL	MSTD	{ int linux_mq_timedsend(void); }
+280	AUE_NULL	MSTD	{ int linux_mq_timedreceive(void); }
+281	AUE_NULL	MSTD	{ int linux_mq_notify(void); }
+282	AUE_NULL	MSTD	{ int linux_mq_getsetattr(void); }
+283	AUE_NULL	MSTD	{ int linux_kexec_load(void); }
+284	AUE_NULL	MSTD	{ int linux_waitid(void); }
+285	AUE_NULL	UNIMPL
+286	AUE_NULL	MSTD	{ int linux_add_key(void); }
+287	AUE_NULL	MSTD	{ int linux_request_key(void); }
+288	AUE_NULL	MSTD	{ int linux_keyctl(void); }
+289	AUE_NULL	MSTD	{ int linux_ioprio_set(void); }
+290	AUE_NULL	MSTD	{ int linux_ioprio_get(void); }
+291	AUE_NULL	MSTD	{ int linux_inotify_init(void); }
+292	AUE_NULL	MSTD	{ int linux_inotify_add_watch(void); }
+293	AUE_NULL	MSTD	{ int linux_inotify_rm_watch(void); }
+294	AUE_NULL	MSTD	{ int linux_migrate_pages(void); }
+295	AUE_NULL	MSTD	{ int linux_openat(void); }
+296	AUE_NULL	MSTD	{ int linux_mkdirat(void); }
+297	AUE_NULL	MSTD	{ int linux_mknodat(void); }
+298	AUE_NULL	MSTD	{ int linux_fchownat(void); }
+299	AUE_NULL	MSTD	{ int linux_futimesat(void); }
+300	AUE_NULL	MSTD	{ int linux_fstatat64(void); }
+301	AUE_NULL	MSTD	{ int linux_unlinkat(void); }
+302	AUE_NULL	MSTD	{ int linux_renameat(void); }
+303	AUE_NULL	MSTD	{ int linux_linkat(void); }
+304	AUE_NULL	MSTD	{ int linux_symlinkat(void); }
+305	AUE_NULL	MSTD	{ int linux_readlinkat(void); }
+306	AUE_NULL	MSTD	{ int linux_fchmodat(void); }
+307	AUE_NULL	MSTD	{ int linux_faccessat(void); }
+308	AUE_NULL	MSTD	{ int linux_pselect6(void); }
+309	AUE_NULL	MSTD	{ int linux_ppoll(void); }
+310	AUE_NULL	MSTD	{ int linux_unshare(void); }
Index: i386/linux/linux_dummy.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/linux/linux_dummy.c,v
retrieving revision 1.40
diff -u -u -r1.40 linux_dummy.c
--- i386/linux/linux_dummy.c	10 May 2006 18:17:29 -0000	1.40
+++ i386/linux/linux_dummy.c	20 Jun 2006 20:36:40 -0000
@@ -68,6 +68,62 @@
 DUMMY(pivot_root);
 DUMMY(mincore);
 DUMMY(fadvise64);
+DUMMY(lookup_dcookie);
+DUMMY(epoll_create);
+DUMMY(epoll_ctl);
+DUMMY(epoll_wait);
+DUMMY(remap_file_pages);
+DUMMY(set_tid_address);
+DUMMY(timer_create);
+DUMMY(timer_settime);
+DUMMY(timer_gettime);
+DUMMY(timer_getoverrun);
+DUMMY(timer_delete);
+DUMMY(clock_settime);
+DUMMY(clock_gettime);
+DUMMY(clock_getres);
+DUMMY(clock_nanosleep);
+DUMMY(statfs64);
+DUMMY(fstatfs64);
+DUMMY(tgkill);
+DUMMY(utimes);
+DUMMY(fadvise64_64);
+DUMMY(mbind);
+DUMMY(get_mempolicy);
+DUMMY(set_mempolicy);
+DUMMY(mq_open);
+DUMMY(mq_unlink);
+DUMMY(mq_timedsend);
+DUMMY(mq_timedreceive);
+DUMMY(mq_notify);
+DUMMY(mq_getsetattr);
+DUMMY(kexec_load);
+DUMMY(waitid);
+DUMMY(add_key);
+DUMMY(request_key);
+DUMMY(keyctl);
+DUMMY(ioprio_set);
+DUMMY(ioprio_get);
+DUMMY(inotify_init);
+DUMMY(inotify_add_watch);
+DUMMY(inotify_rm_watch);
+DUMMY(migrate_pages);
+DUMMY(openat);
+DUMMY(mkdirat);
+DUMMY(mknodat);
+DUMMY(fchownat);
+DUMMY(futimesat);
+DUMMY(fstatat64);
+DUMMY(unlinkat);
+DUMMY(renameat);
+DUMMY(linkat);
+DUMMY(symlinkat);
+DUMMY(readlinkat);
+DUMMY(fchmodat);
+DUMMY(faccessat);
+DUMMY(pselect6);
+DUMMY(ppoll);
+DUMMY(unshare);
 
 #define DUMMY_XATTR(s)						\
 int								\