---  amd64/linux32/linux.h.orig
+++  amd64/linux32/linux.h
@@ -762,7 +762,8 @@
 
 #define LINUX_LOWERWORD	0x0000ffff
 
-/* macros which does the same thing as those in linux include/asm-um/ldt-i386.h 
+/* 
+ * macros which does the same thing as those in linux include/asm-um/ldt-i386.h 
  * these convert linux user-space descriptor to machine one
  */
 #define LDT_entry_a(info) \


---  amd64/linux32/linux32_machdep.c.orig
+++  amd64/linux32/linux32_machdep.c
@@ -512,7 +512,8 @@
 	p2->p_sigparent = exit_signal;
 	PROC_UNLOCK(p2);
 	td2 = FIRST_THREAD_IN_PROC(p2);
-	/* in a case of stack = NULL we are supposed to COW calling process stack
+	/* 
+	 * in a case of stack = NULL we are supposed to COW calling process stack
 	 * this is what normal fork() does so we just keep the tf_rsp arg intact
 	 */
 	if (args->stack)
@@ -628,7 +629,8 @@
 	if (linux_args->flags & LINUX_MAP_GROWSDOWN) {
 		bsd_args.flags |= MAP_STACK;
 
-		/* The linux MAP_GROWSDOWN option does not limit auto
+		/* 
+		 * The linux MAP_GROWSDOWN option does not limit auto
 		 * growth of the region.  Linux mmap with this option
 		 * takes as addr the inital BOS, and as len, the initial
 		 * region size.  It can then grow down from addr without
@@ -655,7 +657,8 @@
 
 		if ((caddr_t)PTRIN(bsd_args.addr) >
 		    p->p_vmspace->vm_maxsaddr) {
-			/* Some linux apps will attempt to mmap
+			/* 
+			 * Some linux apps will attempt to mmap
 			 * thread stacks near the top of their
 			 * address space.  If their TOS is greater
 			 * than vm_maxsaddr, vm_map_growstack()
@@ -683,7 +686,8 @@
 		else
 			bsd_args.len  = STACK_SIZE - GUARD_SIZE;
 
-		/* This gives us a new BOS.  If we're using VM_STACK, then
+		/* 
+		 * This gives us a new BOS.  If we're using VM_STACK, then
 		 * mmap will just map the top SGROWSIZ bytes, and let
 		 * the stack grow down to the limit at BOS.  If we're
 		 * not using VM_STACK we map the full stack, since we


---  compat/linux/linux_emul.c.orig
+++  compat/linux/linux_emul.c
@@ -110,7 +110,8 @@
 	em->child_clear_tid = NULL;
 	em->child_set_tid = NULL;
 
-	/* allocate the shared struct only in clone()/fork cases 
+	/* 
+	 * allocate the shared struct only in clone()/fork cases 
 	 * in the case of clone() td = calling proc and child = pid of 
 	 * the newly created proc
 	 */
@@ -190,9 +191,10 @@
 		cup.uaddr2 = NULL;
 		cup.val3 = 0;
 		error = linux_sys_futex(FIRST_THREAD_IN_PROC(p), &cup);
-		/* this cannot happen at the moment and if this happens
+		/* 
+		 * this cannot happen at the moment and if this happens
 		 * it probably mean there is a userspace bug
-		*/
+		 */
 		if (error)
 		   	printf(LMSG("futex stuff in proc_exit failed.\n"));
 	}
@@ -201,7 +203,8 @@
 	FREE(em, M_LINUX);
 }
 
-/* This is used in a case of transition from FreeBSD binary execing to linux binary
+/* 
+ * This is used in a case of transition from FreeBSD binary execing to linux binary
  * in this case we create linux emuldata proc entry with the pid of the currently running
  * process.
  */
@@ -256,7 +259,8 @@
 	em = em_find(p, EMUL_UNLOCKED);
 
 	if (em == NULL) {
-	   	/* We might have been called before proc_init for this process so
+	   	/* 
+		 * We might have been called before proc_init for this process so
 		 * tsleep and be woken up by it. We use p->p_emuldata for this
 		 */
 


---  compat/linux/linux_emul.h.orig
+++  compat/linux/linux_emul.h
@@ -38,7 +38,8 @@
 	LIST_HEAD(, linux_emuldata) threads;	/* head of list of linux threads */
 };
 
-/* modeled after similar structure in NetBSD 
+/* 
+ * modeled after similar structure in NetBSD 
  * this will be extended as we need more functionality
  */
 struct linux_emuldata {


---  i386/linux/linux.h.orig
+++  i386/linux/linux.h
@@ -725,7 +725,8 @@
 
 #define LINUX_LOWERWORD	0x0000ffff
 
-/* macros which does the same thing as those in linux include/asm-um/ldt-i386.h 
+/* 
+ * macros which does the same thing as those in linux include/asm-um/ldt-i386.h 
  * these convert linux user-space descriptor to machine one
  */
 #define LDT_entry_a(info) \


---  i386/linux/linux_machdep.c.orig
+++  i386/linux/linux_machdep.c
@@ -440,7 +440,8 @@
 	p2->p_sigparent = exit_signal;
 	PROC_UNLOCK(p2);
 	td2 = FIRST_THREAD_IN_PROC(p2);
-	/* in a case of stack = NULL we are supposed to COW calling process stack
+	/* 
+	 * in a case of stack = NULL we are supposed to COW calling process stack
 	 * this is what normal fork() does so we just keep the tf_esp arg intact
 	 */
 	if (args->stack)
@@ -458,7 +459,8 @@
 		
 		idx = info.entry_number;
 		
-		/* looks like we're getting the idx we returned
+		/* 
+		 * looks like we're getting the idx we returned
 		 * in the set_thread_area() syscall
 		 */
 		if (idx != 6 && idx != 3)
@@ -606,7 +608,8 @@
 	if (linux_args->flags & LINUX_MAP_GROWSDOWN) {
 		bsd_args.flags |= MAP_STACK;
 
-		/* The linux MAP_GROWSDOWN option does not limit auto
+		/* 
+		 * The linux MAP_GROWSDOWN option does not limit auto
 		 * growth of the region.  Linux mmap with this option
 		 * takes as addr the inital BOS, and as len, the initial
 		 * region size.  It can then grow down from addr without
@@ -631,7 +634,8 @@
 		bsd_args.addr = linux_args->addr + linux_args->len;
 
 		if (bsd_args.addr > p->p_vmspace->vm_maxsaddr) {
-			/* Some linux apps will attempt to mmap
+			/* 
+			 * Some linux apps will attempt to mmap
 			 * thread stacks near the top of their
 			 * address space.  If their TOS is greater
 			 * than vm_maxsaddr, vm_map_growstack()
@@ -658,7 +662,8 @@
 		else
 			bsd_args.len  = STACK_SIZE - GUARD_SIZE;
 
-		/* This gives us a new BOS.  If we're using VM_STACK, then
+		/* 
+		 * This gives us a new BOS.  If we're using VM_STACK, then
 		 * mmap will just map the top SGROWSIZ bytes, and let
 		 * the stack grow down to the limit at BOS.  If we're
 		 * not using VM_STACK we map the full stack, since we
@@ -994,7 +999,8 @@
 #endif
 
 	idx = info.entry_number;
-	/* Semantics of linux version: every thread in the system has array
+	/* 
+	 * Semantics of linux version: every thread in the system has array
 	 * of 3 tls descriptors. 1st is GLIBC TLS, 2nd is WINE, 3rd unknown. This
 	 * syscall loads one of the selected tls decriptors with a value
 	 * and also loads GDT descriptors 6, 7 and 8 with the content of the per-thread 
@@ -1008,14 +1014,16 @@
 	 * comment in the linux sources says wine might do that.
 	 */
 
-	/* we support just GLIBC TLS now 
+	/* 
+	 * we support just GLIBC TLS now 
 	 * we should let 3 proceed as well because we use this segment so
 	 * if code does two subsequent calls it should succeed
 	 */
 	if (idx != 6 && idx != -1 && idx != 3)
 		return (EINVAL);
 
-	/* we have to copy out the GDT entry we use
+	/* 
+	 * we have to copy out the GDT entry we use
 	 * FreeBSD uses GDT entry #3 for storing %gs so load that 
 	 * XXX: what if userspace program doesnt check this value and tries
 	 * to use 6, 7 or 8? 