Index: i386/linux/linux_sysvec.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/linux/linux_sysvec.c,v
retrieving revision 1.146
diff -u -u -r1.146 linux_sysvec.c
--- i386/linux/linux_sysvec.c	15 Aug 2006 12:54:30 -0000	1.146
+++ i386/linux/linux_sysvec.c	17 Aug 2006 21:05:02 -0000
@@ -62,6 +62,7 @@
 
 #include <i386/linux/linux.h>
 #include <i386/linux/linux_proto.h>
+#include <compat/linux/linux_emul.h>
 #include <compat/linux/linux_mib.h>
 #include <compat/linux/linux_signal.h>
 #include <compat/linux/linux_util.h>
@@ -106,12 +107,7 @@
 static void	exec_linux_setregs(struct thread *td, u_long entry,
 				   u_long stack, u_long ps_strings);
 
-extern void linux_proc_exit(void *, struct proc *, struct image_params *);
-extern void linux_proc_exec(void *, struct proc *, struct image_params *);
-extern void linux_schedtail(void *, struct proc *);
 extern LIST_HEAD(futex_list, futex) futex_list;
-extern struct sx emul_shared_lock;
-extern struct sx emul_lock;
 extern struct mtx futex_mtx;
 
 static eventhandler_tag linux_exit_tag;
Index: i386/linux/linux_machdep.c
===================================================================
RCS file: /home/ncvs/src/sys/i386/linux/linux_machdep.c,v
retrieving revision 1.52
diff -u -u -r1.52 linux_machdep.c
--- i386/linux/linux_machdep.c	16 Aug 2006 18:54:51 -0000	1.52
+++ i386/linux/linux_machdep.c	17 Aug 2006 21:05:02 -0000
@@ -67,9 +67,6 @@
 
 #include "opt_posix.h"
 
-extern struct sx emul_shared_lock;
-extern struct sx emul_lock;
-
 extern struct sysentvec elf32_freebsd_sysvec;	/* defined in i386/i386/elf_machdep.c */
 
 struct l_descriptor {
Index: compat/linux/linux_emul.h
===================================================================
RCS file: /home/ncvs/src/sys/compat/linux/linux_emul.h,v
retrieving revision 1.2
diff -u -u -r1.2 linux_emul.h
--- compat/linux/linux_emul.h	16 Aug 2006 18:54:50 -0000	1.2
+++ compat/linux/linux_emul.h	17 Aug 2006 21:05:02 -0000
@@ -72,4 +72,7 @@
 void linux_schedtail(void *, struct proc *);
 void linux_proc_exec(void *, struct proc *, struct image_params *);
 
+extern struct sx emul_shared_lock;
+extern struct sx emul_lock;
+
 #endif /* !_LINUX_EMUL_H_ */
Index: compat/linux/linux_misc.c
===================================================================
RCS file: /home/ncvs/src/sys/compat/linux/linux_misc.c,v
retrieving revision 1.182
diff -u -u -r1.182 linux_misc.c
--- compat/linux/linux_misc.c	15 Aug 2006 15:15:17 -0000	1.182
+++ compat/linux/linux_misc.c	17 Aug 2006 21:05:02 -0000
@@ -94,9 +94,6 @@
 #define BSD_TO_LINUX_SIGNAL(sig)	\
 	(((sig) <= LINUX_SIGTBLSZ) ? bsd_to_linux_signal[_SIG_IDX(sig)] : sig)
 
-extern struct sx emul_shared_lock;
-extern struct sx emul_lock;
-
 static unsigned int linux_to_bsd_resource[LINUX_RLIM_NLIMITS] = {
 	RLIMIT_CPU, RLIMIT_FSIZE, RLIMIT_DATA, RLIMIT_STACK,
 	RLIMIT_CORE, RLIMIT_RSS, RLIMIT_NPROC, RLIMIT_NOFILE,
Index: compat/linux/linux_signal.c
===================================================================
RCS file: /home/ncvs/src/sys/compat/linux/linux_signal.c,v
retrieving revision 1.57
diff -u -u -r1.57 linux_signal.c
--- compat/linux/linux_signal.c	15 Aug 2006 12:54:29 -0000	1.57
+++ compat/linux/linux_signal.c	17 Aug 2006 21:05:03 -0000
@@ -51,9 +51,6 @@
 #include <compat/linux/linux_util.h>
 #include <compat/linux/linux_emul.h>
 
-extern struct sx emul_shared_lock;
-extern struct sx emul_lock;
-
 void
 linux_to_bsd_sigset(l_sigset_t *lss, sigset_t *bss)
 {
Index: amd64/linux32/linux32_sysvec.c
===================================================================
RCS file: /home/ncvs/src/sys/amd64/linux32/linux32_sysvec.c,v
retrieving revision 1.22
diff -u -u -r1.22 linux32_sysvec.c
--- amd64/linux32/linux32_sysvec.c	17 Aug 2006 10:04:49 -0000	1.22
+++ amd64/linux32/linux32_sysvec.c	17 Aug 2006 21:05:03 -0000
@@ -125,8 +125,6 @@
 
 extern LIST_HEAD(futex_list, futex) futex_list;
 extern struct mtx futex_mtx;
-extern struct sx emul_shared_lock;
-extern struct sx emul_lock;
 
 static eventhandler_tag linux_exit_tag;
 static eventhandler_tag linux_schedtail_tag;